#!/usr/bin/env python

import  sys, string
import time

# commands: used for shell operations (sendmail, mkdir etc.)
from commands import *

# creates a directory that holds the errors (good for debugging)
# Alex: change ./tmp directory to a more secure one (e.g. /tmp or ../tmp)
import cgitb; cgitb.enable()
# import cgitb; cgitb.enable(display=0, logdir="tmp")
# Alex: for UNIX use next line (instead of previous)
# import cgitb; cgitb.enable(display=0, logdir="tmp")

from global_vars import *

class getSVSchedules:
  def __init__ (self):
    print 'Content-type: text/html \n\n'
    print ''
    self.user_list = {} #list of all SVs
    self.task_list = {} #list of all tasks
    self.last_name  = '' #last name
    self.first_name = '' #first name
    self.total_hours = [0,0] #total hours scheduled
    self.error = [] #Errors
    self.user_info = [] #Info from user's tasks
    try:
        self.form=get_form_info.get_form()
    except:
        self.error ('There is something wrong with the WWW server', 1)
    val = self.form['listType'].value 
    
    if val == 'allSchedules':
        self.show_all_schedules()
    elif val == 'hoursByCategory':
        self.show_hours_tasksLeft()
    else:
        self.show_task_assignment()
    print  '  </body>'
    print  '</html>'
    
  def show_task_assignment(self):
     self.get_assigments_list()
     self.get_task_location()
     #print self.task_list 
     if not self.error:
	print '    <br><br>'
	print '    <b>Tasks location and SV assigments</b><br><br>'
	print '    <table border cellpadding=1 cellspacing=0>'
	print '      <tr>'
	print '        <th>TaskID</th>'
	print '        <th>Category</th>'
	print '        <th>Date</th>'
	print '        <th>Start time</th>'
	print '        <th>End time</th>'
	print '        <th>Duration</th>'
	print '        <th>Description</th>'
	print '        <th>SV</th>'
	print '        <th>Location</th>'
	print '      </tr>'

        try:
          input = open (taskByDate_filename, 'r')
        except:
          self.error ("get task by id list", "file could not be opened.")
          return
        for line in input.readlines():
            strtok = line.split('\t')
            task_id = strtok[0]
            try:
                task_cat = self.task_list[strtok[0]][0]
            except:
                break
            taskfilename = task_checked_folder + task_cat + '/'+ task_id + task_checked_ext
            i=0
            print '      <tr>' 
            print '        <th>%s </th>' %task_id
            while i < 8:
                print '        <th>%s </th>' % self.task_list[strtok[0]][i]
                i = i + 1
            print '      </tr>'   
  	print '    </table>'  
        input.close()      
  
  def show_hours_tasksLeft(self):
    self.get_tasks_list()
    self.check_errors()
    self.show_all_hours()      	
    self.show_task_notaken()

  
  def show_task_notaken(self):
    if not self.error:
	print '    <br><br>'
	print '    <b>Tasks Available</b><br><br>'
	print '    <table border cellpadding=1 cellspacing=0>'
	print '      <tr>'
	print '        <th>TaskID</th>'
	print '        <th>Category</th>'
	print '        <th>Date</th>'
	print '        <th>Start time</th>'
	print '        <th>End time</th>'
	print '        <th>Duration</th>'
	print '        <th>Description</th>'
	print '      </tr>'

        try:
          input = open (taskById_filename, 'r')
        except:
          self.error ("get task by id list", "file could not be opened.")
          return
        for line in input.readlines():
            strtok = line.split('\t')
            task_id = strtok[0]
            try:
                task_cat = self.task_list[strtok[0]][0]
            except:
                break
            taskfilename = task_checked_folder + task_cat + '/'+ task_id + task_checked_ext

            # If the tasks has not been selected
            if self.file_exist(taskfilename)==0 :
                i=0
		print '      <tr>' 
                print '        <th>%s </th>' %task_id
	        while i < 6:
   		    print '        <th>%s </th>' % self.task_list[task_id][i]
		    i = i + 1
		print '      </tr>'   
  	print '    </table>'  
  
  def show_all_hours (self):
    hoursByCategory = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    hoursByCategoryTaken = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    temp1 =[0,0] 
    temp2 =[0,0] 
    task_duration = [0,0]
    
    if not self.error:
        for t in self.task_list:
            task_id = t
            task_cat = string.atoi(self.task_list[t][0])
            task_duration = self.convert2array(self.task_list[t][4])
            
            pos = (task_cat-1)*2
            temp1 = [hoursByCategory[pos], hoursByCategory[pos+1]]
            temp2 = self.addHours(temp1,task_duration)           
            hoursByCategory[pos] = temp2[0]
            hoursByCategory[pos+1] = temp2[1]
            
            taskfilename = task_checked_folder + self.task_list[t][0] + '/'+ task_id + task_checked_ext
            
            #print taskfilename
            if self.file_exist(taskfilename)==1 :
                temp1 = [hoursByCategoryTaken[pos], hoursByCategoryTaken[pos+1]]
                temp2 = self.addHours(temp1,task_duration)  
                hoursByCategoryTaken[pos] = temp2[0]
                hoursByCategoryTaken[pos+1] = temp2[1]
                
    print '    <br>'
    print '    <table border cellpadding=1 cellspacing=0>'
    print '      <tr>'
    print '        <th>Category</th>'
    print '        <th>Total hours</th>'
    print '        <th>Hours scheduled</th>'
    print '      </tr>'
    i=0
    while i < 8:
        print '      <tr>'    
        print '        <th>%s </th>' % (i+1)
        print '        <th>%s:%s </th>' % (hoursByCategory[i*2],hoursByCategory[i*2+1])
        print '        <th>%s:%s </th>' % (hoursByCategoryTaken[i*2],hoursByCategoryTaken[i*2+1])
        print '      </tr>'   
        i = i + 1
    print '    </table>'            

    
  def show_all_schedules (self):
    self.get_user_list()
    self.check_errors()
    if not self.error:
       for u in self.user_list:
          self.first_name = u
          self.last_name = self.user_list[u][0]
       	  self.get_info_from_file ()
       	  self.calc_hours_per_sv ()
       	  self.get_tasks_list ()
          self.get_assigments_list()
          self.get_task_location()
       	  self.print_tasks() 
       	  
  def get_user_list (self):
    try:
      input = open (pasfilename, 'r')
    except:
      self.error ("get password list", "file could not be opened.")
      return
    for line in input.readlines():
      strtok = line.split(',')
      self.user_list [strtok[0]] = strtok[1:4]
    input.close()

  def get_tasks_list (self):
    try:
      input = open (taskById_filename, 'r')
    except:
      self.error ("get task by id list", "file could not be opened.")
      return
    for line in input.readlines():
      strtok = line.split('\t')
      self.task_list [strtok[0]] = strtok[1:7]
    input.close()      

  def get_assigments_list (self):
    try:
      input = open (taskById_filename, 'r')
    except:
      self.error ("get task by id list", "file could not be opened.")
      return
    for line in input.readlines():
      strtok = line.split('\t')
      temp = ['','','','','','','none','n/a']
      temp[0:6] = strtok[1:7]
      self.task_list [strtok[0]] = temp
      self.find_sv_assigned(strtok[0])
    input.close() 

  def find_sv_assigned(self,task_id):
     try:
         task_cat = self.task_list[task_id][0]
     except:
         return
     taskfilename = task_checked_folder + task_cat + '/'+ task_id + task_checked_ext
     sv_list=''
     try:
         input = open (taskfilename, 'r')
     except:
         return
     for line in input.readlines():
         strtok = line.split(' ')
         sv_list = sv_list + strtok[0] + ' ' 
     self.task_list[task_id][6] = sv_list  
     input.close() 


  def get_task_location (self):
      #print '<p>Error(s):'
      try:
          input = open (all_tasks_filename, 'r')
      except:
          return
      for line in input.readlines():
          strtok = line.split('\t')
          self.task_list[strtok[0]][7] = strtok[8]
      input.close() 
     

  def check_errors (self):
    if self.error:
      print '<p>Error(s):'
      i = 1
      for e in self.error:
        print '<p>%d) %s %s</p>' % (i, e[0], e[1])
        i = i + 1
      print '<p>If errors persist, please contact the VisWeek Student volunteers chairs at:<br>'
      print 'vis08sv@gmail.com</p>'
      sys.exit(0)

  def get_info_from_file (self):
    filename = users_path + self.first_name + task_list_ext
    self.user_info = []
    #print filename
    try:
      input = open (filename, 'r')
    except:
      #self.error ('Could not open user\'s file %s' % filename, 1)
      return
    for line in input.readlines():
      strtok = line.split ('\t')
      new_tok = strtok[:-1]
      new_tok.append (strtok[-1][:-1])
      self.user_info.append (new_tok)
    input.close()  
  
  def calc_hours_per_sv (self):
    totalTime = [0,0]
    temp = [0,0]
    for ui in self.user_info:
      temp = self.convert2array(ui[6])
      totalTime = self.addHours(totalTime, temp)
    self.total_hours = totalTime 
    
  def addHours(self, val1, val2):
      temp = [0,0]
      th = int ((val1[1] + val2 [1] ) / 60)
      temp [0] = int (val1[0] + val2 [0] + th)
      temp [1] = int (val1[1] + val2 [1] - 60*th )
      return temp

  def convert2array (self, hour_str):
    tok = hour_str.split (':')
    temp = [string.atof(tok[0]), string.atof(tok[1])]
   #ctn = temp[0] + temp[1]/60.0
    return temp
    
    
  def print_tasks (self):
    print '    <br><br>'
    print '    <b>%s %s<br></b>' % (self.first_name, self.last_name)
    print '    <table border cellpadding=1 cellspacing=0>'
    print '      <tr>'
    print '        <th>TaskID</th>'
    print '        <th>Category</th>'
    print '        <th>Date</th>'
    print '        <th>Start time</th>'
    print '        <th>End time</th>'
    print '        <th>Duration</th>'
    print '        <th>Description</th>'
    print '        <th>Location</th>'
    print '      </tr>'


    for ui in self.user_info:
      print '      <tr>'
      i = 0
      for u in ui[:-1]:
        if i == 0:
          print '        <td align="center">%s' % u
          tempID = u
          print '        </td>'
        else:
          if i == 7:
            print '        <td>%s</td>' % self.task_list[tempID][5]
            print '        <td>%s</td>' % self.task_list[tempID][7]
          if i not in [2, 7]:
            if i==3:
               print '        <td>%s %s</td>' % (u, day_str)
            else:
               print '        <td align="center">%s</td>' % u
          else:
            if i <> 2:
              pass
            else:
              day_str = u
        i = i + 1
    
    print '    </table>'
    print '    Total hours: %s:%s<br>' %(self.total_hours [0],self.total_hours [1])

  def file_exist (self, filename):
    try:
      input = open (filename, 'r')
    except:
      return 0  # does not exist
    input.close()
    return 1    # it exists

#main
getSVSchedules()
