#!/usr/bin/env python

import csv

reader = csv.reader(file('tasks.csv'),dialect='excel')

date_map = {'Saturday': '10/10/2009',
            'Sunday': '10/11/2009',
            'Monday': '10/12/2009',
            'Tuesday': '10/13/2009',
            'Wednesday': '10/14/2009',
            'Thursday': '10/15/2009',
            'Friday': '10/16/2009',
            }

class Task:
    pass

tasks = []

def make_format(l):
    l = l.replace('m', '').replace('h', ':').replace(' ','')
    if l.endswith(':'): l = l + '00'
    elif ':' not in l: l = '0:' + l
    return l

for l in reader:
    try:
        taskid = int(l[0])
    except:
        print "skipping line", l
        continue
    l[3] = l[3].strip()
    t = Task()
    (t.id, t.category, t.date,
     t.weekday, t.starttime, t.endtime, t.duration,
     t.name) = (l[0], l[1], date_map[l[3]], l[3], l[4], l[5],
                make_format(l[6]), l[7])
    tasks.append(t)

f = file('tasks_visweek.txt', 'w')
for t in sorted(tasks, key=lambda t:t.id):
    print >>f, "\t".join([t.id, t.category,t.date,
                          t.weekday, t.starttime,
                          t.endtime, t.duration, t.name])
f.close()

f = file('tasks_byID.txt', 'w')
for t in sorted(tasks, key=lambda t:t.id):
    print >>f, "\t".join([t.id, t.category, t.weekday,
                          t.starttime, t.endtime, t.duration, t.name])
f.close()

f = file('tasks_byDate.txt', 'w')
for t in sorted(tasks, key=lambda t:(t.date, t.starttime, t.endtime)):
    print >>f, "\t".join([t.id, t.category, t.weekday,
                          t.starttime, t.endtime, t.duration, t.name,
                          t.date])
f.close()
