function task(id, category, date, 
	      dayofweek, start, end, 
	      duration, name, location, available)
{
    this.id = id;
    this.category = category;
    this.date = date;
    this.dayofweek = dayofweek;
    this.start = start;
    this.end = end;
    this.duration = duration;
    this.name = name;
    this.location = location;
    this.available = available;
    this.row_element = function()
    {
    	var row = document.createElement("tr");
	var el = document.createElement("td");
	var myself = this;
	var date_map = { 
	    "10/9/2009": "Fri 9th",
	    "10/10/2009": "Sat 10th",
	    "10/11/2009": "Sun 11th",
	    "10/12/2009": "Mon 12th",
	    "10/13/2009": "Tue 13th",
	    "10/14/2009": "Wed 14th",
	    "10/15/2009": "Thu 15th",
	    "10/16/2009": "Fri 16th",
	};
	if (this.available) {
	    var add_el = document.createElement("a");
	    add_el["href"] = ""; // "javascript:add_task(" + myself.id + ")";
	    add_el.onclick = function () {
 		update_form('myForm');
		document.myForm.taskID.value = myself.id;
		document.myForm.submit();
		return false;
	    }
	    add_el.innerHTML = "Add!";
	    el.appendChild(add_el);
	} else {
	    el.innerHTML = "N/A";
	}
	row.appendChild(el);
	[this.id, this.category,
	 this.date, this.start, this.end,
	 this.duration, this.name].forEach(
	     function(field) {
		 var el = document.createElement("td");
		 if (field in date_map) {
		     el.innerHTML = date_map[field];
		 } else {
		     el.innerHTML = field;
		 }
		 row.appendChild(el);
	     });
	return row;
    };
    this.duration_in_minutes = function()
    {
	var hours = parseInt(duration.substring(0,1));
	var minutes = parseInt(duration.substring(2,4));
	return hours * 60 + minutes;
    }
}

function task_table(filter, sort_criterion)
{
    var table_el = document.createElement("table");
    table_el.className = "viewcalendar";
    var table_header = document.createElement("tr");
    var th_width = {
	"Name": "300",
	"Date": "100"
    };
    ["", "ID", "Cat.", "Date", "Start", 
     "End", "Duration", "Name"].forEach(
	 function(field) {
	     var el = document.createElement("th");
	     el.innerHTML = field;
	     table_header.appendChild(el);
	     if (field in th_width) {
		 el.width = th_width[field]
	     } else {
		 el.width = "50";
	     }
	 });
    table_el.appendChild(table_header);
    var table_rows = [];
    for (var task_id = 0; task_id < all_tasks.length; ++task_id) { // in all_tasks) {
	var task = all_tasks[task_id];
	if (filter(task)) {
	    table_rows.push(task);
	}
    }
    table_rows.sort(sort_criterion);
    for (var i = 0; i < table_rows.length; ++i) { // in table_rows) {
	var task = table_rows[i];
	table_el.appendChild(task.row_element());
    }
    return table_el;
}

function sort_table_by_id(ta, tb)
{
    return parseInt(ta.id) - parseInt(tb.id);
}

function time_to_minutes(t)
{
    v = t.split(':');
    return parseInt(v[0]) * 60 + parseInt(v[1]);
}

function sort_table_by_date(ta, tb)
{
    var v1 = parseInt(ta.date.substr(3, 5)) - parseInt(tb.date.substr(3, 5));
    if (v1 != 0) {
	return v1;
    }
    return time_to_minutes(ta.start) - time_to_minutes(tb.start)
}

function sort_table_by_duration(ta, tb)
{
    return tb.duration_in_minutes() - ta.duration_in_minutes();
}

function reset_task_table()
{
    var div = document.getElementById("tasklist");
    var old_scroll_pos = div.scrollTop;
    while (div.hasChildNodes()) {
	div.removeChild(div.lastChild);

    }
    return old_scroll_pos;
}

function get_radio_button_value(radio_group)
{
    for (var i=0; i<radio_group.length; ++i) {
	if (radio_group[i].checked) {
	    return radio_group[i].value;
	}
    }
}

function clear_search()
{
    document.search.search_criterion.value = "";
    perform_search();
}

function perform_search()
{
    if (document.search.search_criterion.length == 0)
	var regexp = "";
    else
	var regexp = new RegExp(document.search.search_criterion.value, "i");
    var radio_val = get_radio_button_value(document.search.task_availability);
    switch (radio_val) {
    case 'all': 
	var criterion = function(t) {
	    if (!document.search["cat" + t.category].checked) {
		return false;
	    }
	    return t.name.match(regexp);
	}; 
	break;
    case 'available':
	var criterion = function(t) {
	    if (!document.search["cat" + t.category].checked) {
		return false;
	    }
	    var result = t.available && t.name.match(regexp); 
	    return result;
	};
	break;
    default:
	alert(radio_val);
    }
    switch (get_radio_button_value(document.search.sort_by)) {
    case 'date': var sort_by = sort_table_by_date; break;
    case 'id': var sort_by = sort_table_by_id; break;
    case 'length': var sort_by = sort_table_by_duration; break;
    }
    var tasklist_div = document.getElementById("tasklist");
    var old_scrolltop = reset_task_table();
    tasklist_div.appendChild(task_table(criterion, sort_by));
    tasklist_div.scrollTop = old_scrolltop;
}

function noenter() {
  return !(window.event && window.event.keyCode == 13); 
}

function get_box_by_name(list, name)
{
    for (var i=0; i<list.length; ++i) {
	if (list[i].value == name) {
	    return list[i];
	}
    }
}

function update_form(which_form) 
{
    var checked_boxes_value = "";
    var form = document[which_form];
    for (var i=1; i<=8; ++i) {
	if (document.search["cat"+String(i)].checked) {
	    checked_boxes_value = checked_boxes_value + String(i);
	}
    }
    form.checked_boxes.value = checked_boxes_value;
    ["date", "id", "length"].forEach( function (i) {
	var radio_box = get_box_by_name(document.search.sort_by, i);
	if (radio_box.checked) {
	    form.sort_by.value = i;
	};
    });
    ["all", "available"].forEach( function(i) {
	if (get_box_by_name(document.search.task_availability, i).checked) {
	    form.task_availability.value = i;
	}
    });
    form.search_criterion.value = document.search.search_criterion.value;
    return true;
}
