#!/usr/bin/env python

import twitter
import datetime
import time

username = 'visweek'
password = 'VisWeek_Twitter'

CHARACTER_LIMIT = 140

##############################################################################

class DummyAPI(twitter.Api):

    def PostUpdate(self, status, in_reply_to_status_id=None):
        """Overrides twitter.Api.PostUpdate to actually not post the
        json update"""
        if not self._username:
            raise TwitterError("The twitter.Api instance must be authenticated.")
        if len(status) > CHARACTER_LIMIT:
            raise TwitterError("Text must be less than or equal to %d characters. "
                               "Consider using PostUpdates." % CHARACTER_LIMIT)
        print "WOULD HAVE POSTED", status

api = DummyAPI(username, password)

class EDT(datetime.tzinfo):
    def utcoffset(self, dt):
        return -datetime.timedelta(hours=4)
    def tzname(self, dt):
        pass
    def dst(self, dt):
        return datetime.timedelta(0)

class MDT(datetime.tzinfo):
    def utcoffset(self, dt):
        return -datetime.timedelta(hours=2)
    def tzname(self, dt):
        pass
    def dst(self, dt):
        return datetime.timedelta(0)

edt = EDT()
mdt = MDT()

class Event(object):

    def __init__(self, line):
        (d, t, post) = line.strip().split('\t')
        self.post = post
        w = len("Coming up :") + len(" #visweek")
        if len(post) > (140 - w):
            raise Exception("post too long (%d): %s" % (len(post) + w, post))
        self.time = datetime.datetime(int(d[6:10]), int(d[0:2]), int(d[3:5]),
                                      int(t[0:2]), int(t[3:5]),
                                      tzinfo=edt)

f = file('event_list.txt')
events = list(Event(l) for l in f)
sleep_for = 10

while 1:
    e = events[0]
    d = e.time - datetime.datetime.now(edt)
    while d > datetime.timedelta(minutes=10):
        total = d.days * 86400.0 + d.seconds
        print "Sleeping, next one due in", total
        time.sleep(sleep_for)
        d = e.time - datetime.datetime.now(edt)
    if (d < datetime.timedelta(0)):
        print "post overdue: ", e.post
        print "skipping"
        del events[0]
        continue
    api.PostUpdate("Coming up: " + e.post + " #visweek")
    del events[0]
    
#     for e in events:
#         d = (e.time - now)
#         print d.days * 86400.0 + d.seconds, e.post
    
