#!/usr/bin/env python

# Analyze _log.txt files to track down frequency of actions
##############################################################################

import cgitb
cgitb.enable()
from global_vars import *
import os.path

print "Content-type: text/plain\n"
print 'log analysis'

def time_difference(t1, t2):
    (h1, m1, s1) = list(int(i) for i in t1.split(':'))
    (h2, m2, s2) = list(int(i) for i in t2.split(':'))
    d = (h2 - h1) * 3600 + (m2 - m1) * 60 + (s2 - s1)
    if d < 0: d += 24 * 3600
    return d

users = []
for f in file('task_data/usersfile.txt'):
    username = f.split()[0]
    print "User %s:" % username
    logname = 'task_data/users/%s_log.txt' % username
    if not os.path.isfile(logname):
        print "  no actions\n"
        continue
    
    times = list(l.strip().split()[-1] for l in file(logname))
    deltas = []
    for (this, next) in zip(times[:-1], times[1:]):
        delta = time_difference(this, next)
        print "  Delta: %ds" % delta
        deltas.append(delta)
    if len(deltas) > 0:
        print "  -- Median delta: %d" % sorted(deltas)[len(deltas)/2]
        users.append((username, sorted(deltas)[len(deltas)/2]))
    print ""
    
users.sort(key=lambda k:k[1])
print "--------"
print "In order of suspicion:"

for (user, median_delta) in users:
    print "User %s, (median add time=%d)" % (user, median_delta)
