#!/usr/bin/env python

# Reads the entire database and produces a summary of students and their
# tasks
##############################################################################

import cgitb
cgitb.enable()
from tasks import read_all_tasks
from global_vars import *
import display_progress
from get_form_info import get_form

tasks = dict((t.id, t) for t in read_all_tasks())

for task in tasks.itervalues():
    task.set_owner()

def nice_time(minutes):
    return "%d:%02d" % (minutes / 60, minutes % 60)

def ascii_time_to_int(t):
    (h, m) = list(int(i) for i in t.split(':'))
    return h * 60 + m

day = get_form()["day"].value

print "Content-type: text/html\n"
print '<html><head><title>Tasks for %s</title>' % day

print """<style type='text/css'> td { border: 1px solid; }</style>"""
print '</head><body>'

# print '<pre>'
# print ", ".join(str(x.id) for x in tasks.values())
# print '</pre>'
print '<div style="td { border: 1px solid; }">'
print '<table border=1 cellpadding=1 cellspacing=0 width=100%>'
print '<th>id</th><th>start</th><th>end</th><th>name</th><th>location</th><th>owner</th><th>sign in</th><th>sign out</th><th>comments</th>'
for task in sorted((t for t in tasks.values() if t.date == day),
                   key=lambda k: (ascii_time_to_int(k.start), ascii_time_to_int(k.end))):
    print task.dump_tr(['id', 'start', 'end', 'name', 'location', 'owner', 'sign in', 'sign out', 'comments'],
                       {'sign in': 'width=10%',
                        'sign out': 'width=10%',
                        'comments': 'width=20%'})
print '</table>'
print '</div>'
