#!/usr/bin/env python

# All this junk would be better done with <div> elements. It would
# also allow for better control over placement of task boxes.
# However, I'm not inclined to do it right now. --cscheid, 2009/09/17
# 15:08 EDT
#
##############################################################################

import sys, string
import display_tasks
import sha
import get_form_info
from task_colors import get_task_colors
import utils
import nice_display
import os.path
from global_vars import *

class display_progress:
    def __init__ (self, user=None, last=None):
        self.user_info = []
        self.user_colors = {}
        self.dates = ['start', '10/9/2009', '10/10/2009', '10/11/2009', '10/12/2009', '10/13/2009', '10/14/2009', '10/15/2009', '10/16/2009', 'end']
        self.dateswday = ['Fri 9th', 'Sat 10th', 'Sun 11th', 'Mon 12th', \
                          'Tue 13st', 'Wed 14th', 'Thu 15th', 'Fri 16th']
        self.minutes = ['00','15','30','45']
        if not user:
            self.get_info_from_form()
        else:
            self.user = user
            self.last = last
        self.get_info_from_file()

    def get_info_from_form(self):
        try:
            self.form=get_form_info.get_form()
        except:
            self.error ('(208) Getting info from form', 1)
            return
        self.user = self.form['user'].value
        try:
            self.last = utils.get_password_list()[self.user][0]
        except:
            self.last = ''

    def get_info_from_file (self):
        filename = users_path + self.user + task_list_ext
        if not os.path.isfile(filename):
            try:
                file(filename, 'w').close() # create file
            except:
                self.error('Could not create user\'s file %s' % filename, 1)
        try:
            input = open (filename, 'r')
        except:
            self.error ('Could not open user\'s file %s' % filename, 1)
        for line in input.readlines():
            strtok = line.split ('\t')
            new_tok = strtok[:-1]
            new_tok.append (strtok[-1][:-1])
            self.user_info.append (new_tok)
            
    def gen_html (self):
        self.print_headers ()
        self.print_table()
        self.print_tasks()
        self.print_footers()

    def print_headers (self):
        print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"'
        print '   "http://www.w3.org/TR/html4/loose.dtd">'
        print '<html lang=en>'
        print '  <head>'
        print '    <meta http-equiv="Content-Type" content="text/html;charset=utf-8" >'
        print '    <link rel="STYLESHEET" title="top" media="screen"',
        print 'href="styles/middle_style.css" type="text/css" >'
        print '    <title>%s Schedule</title> ' % self.user
        print '  </head>'
        print '  <body>'
        print  '   <center>'
        print '    <H2> %s %s tasks\' schedule </H2>' % (self.user, self.last)
    
    def print_table (self):
        self.convert2nums ()
        if len(self.user_info) == 0:
            print "<div class='Heading'><b>No tasks yet!</b></div>"
            return
        print '    <center><table class="calendarview" border=1 padding=0 >'
        print '      <tr>'
        print '        <th></th>'
        for day in self.dateswday:
            print '        <th>%s</th>' % day
        max_user_hours = int(self.maxi) - int (self.mini)
        max_slots = max_user_hours * 4 + 4
        active_tasks = {}
        for hour in range (max_slots + 2):
            print '      </tr>'
            #calculating the printing time
            start_str = '%d:%s' % (hour/4 + self.mini, self.minutes[hour%4])
            #start row
            print '      <tr>'
            #starting with time
            if (hour%2==0):
                print '        <td align="right" rowspan=2 valign="top">%s</td>' % start_str
            starting_tasks = {}
            in_between_tasks = {}
            # then, check for every day:
            for day in self.dates:
                # how many tasks would start at this time
                to_display = self.is_start (day, start_str)
                if to_display:
                    # add them up
                    starting_tasks[to_display[0]] = to_display[1:]
                else:
                    # check if they are in between
                    between = self.in_between (day, start_str)
                    if between:
                        in_between_tasks[between[0]] = between[1]
            # Then just print the tasks out
            st = starting_tasks
            for day in self.dates:
                if day == 'start' or day == 'end':
                    continue
                if st.has_key(day):
                    bgcolor, color = get_task_colors(st[day][1])
                    if st[day][0] > 1:
                        active_tasks[day] = st[day][0] + hour - 1
                    print '        <td rowspan=%d align="center" bgcolor="%s"><font color="%s">%s<br><a href="" onclick="drop_task(%s); return false;">Drop</a></font></td>' % \
                             (st[day][0], bgcolor, color, st[day][1], st[day][1])

                elif not in_between_tasks.has_key (day) and day not in active_tasks:
                    print '        <td></td>'
                if active_tasks.get(day, -1) == hour:
                    del active_tasks[day]
        print '      </tr>'
        print '    </table></center>'

    def in_between (self, day, hour_str):
        for ut in self.user_times:
            if ut[1] == day:
                look_time = self.convert2float (hour_str)
                if ut[2] < look_time < ut[3]:
                    return (day, ut[0])
        return 0

    def convert2float (self, hour_str):
        time_tok = hour_str.split(':')
        time_hrs = string.atof (time_tok[0])
        time_min = string.atof(time_tok[1])/60.0
        return (time_hrs + time_min)

    def is_start (self, day, hour):
        hnum = self.convert2float(hour)
        for ui in self.user_info:
            if ui[2] == day:
                unum = self.convert2float(ui[4])
                if abs(hnum-unum) < 0.1:
                    slots = self.conv2quaters (ui[6])
                    return (day, slots, ui[0])
        return 0

    def conv2quaters (self, hour_str):
        time_tok = hour_str.split(':')
        time_hrs = string.atof (time_tok[0])
        time_min = string.atof(time_tok[1])/60.0
        time_hours = time_hrs * 4
        time_minutes = time_min * 4
        total_slots = (int(time_hours) + int (time_minutes) ) 
        return total_slots
        

    def convert2nums (self):
        i = 0
        self.user_times = []
        if len(self.user_info) == 0:
            return
        for ui in self.user_info:
            start_tok = ui[4].split(':')
            start_time = string.atof (start_tok[0]) + string.atof(start_tok[1])/60.0
            end_tok = ui[5].split(':')
            end_time = string.atof (end_tok[0]) + string.atof(end_tok[1])/60.0
            duration_time = end_time - start_time
            if i == 0:
                mini = start_time
                maxi = end_time
                i = 1
            if mini > start_time:
                mini = start_time
            if maxi < end_time:
                maxi = end_time
            self.user_times.append ((ui[0], ui[3], start_time, end_time, duration_time))
        self.mini = mini
        self.maxi = maxi
        #print self.user_times

    def print_tasks (self, interactive=True, sort_key=lambda k:k[0]):
        if len(self.user_info) == 0:
            print '<div class="Heading"><b>No tasks yet!</b></div>'
            return
        print '    <center><table class="calendarview" border=1>'
        print '      <tr>'
        print '        <th>ID</th>'
        print '        <th>Cat.</th>'
        print '        <th>Date</th>'
        print '        <th>Start</th>'
        print '        <th>End</th>'
        print '        <th>Duration</th>'
        print '        <th width=200>Description</th>'
        print '      </tr>'
        for ui in sorted(self.user_info, key=sort_key):
            print '      <tr>'
            for i, u in enumerate(ui):
                if i == 0:
                    bgcolor, color = get_task_colors(u)
                    print '        <td align="center" bgcolor="%s"><font color="%s">%s</font>' % \
                             (bgcolor, color, u)
                    if interactive:
                        print ' <a href="" onclick="drop_task(%s); return false;">Drop</a>' % u
                    print '        </td>'
                elif i == 2:
                    # self.dateswday[self.dateswday.index(u) - 1]
                    print '<td>%s</td>' % u
                elif i == 3:
                    continue
                elif i <> 8:
                    print '<td>%s</td>' % u
            print '      </tr>'
        print '    </table></center><br>'


    def print_footers (self):
        print '    <br><br><br><br>'
        print '        <form name ="myDropForm" action="drop_task.py" onsubmit="return drop_task_confirm()">'
        print '          <input type="hidden" name="user" value="%s">' % self.user
        print '          <input type="hidden" name="last_name" value="%s">' % self.last
        print '          <input type="hidden" name="drop_taskID" value="0">'
        print '          <input type="submit" value="Back" class="drop_button">'
        print '        </form>'    
        print  '    </center>'
        print '    <br><br><br><br>'
        print  '  </body>'
        print  '</html>'

    def error (self, text, type):
        print "<h1> %s %s</h1>" % (type, text)
        sys.exit(0)
