#!/usr/bin/env python

import sys, string, cgi
import display_tasks
from global_vars import *

class display_schedule:
  def __init__ (self, user, last):
    self.user = user
    self.last = last
    self.user_info = []
    self.user_colors = {}
    self.task_location = {}
    self.dates = ['start', 'Saturday', 'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday','end']
    self.dateswday = ['Saturday<br>10/18/08', 'Sunday<br>10/19/08', 'Monday<br>10/20/08', \
	             'Tuesday<br>10/21/08', 'Wednesday<br>10/22/08', 'Thursday<br>10/23/08', 'Friday<br>10/24/08']
    self.minutes = ['00','15','30','45']
    self.colors = ["#7FFFD4", "#6495ED", "#D2691E", "#FF7F50", "#DC143C", "#B8860B", \
	           "#008B8B", "#A9A9A9", "#228B22", "#FFB6C1", "#FFA500", "#EE82EE", \
                   "#000033", "#0000CC", "#660000", "#996600", "#191970", "#800000", \
		   "#00008B", "#4B0082", "#800080", "#2F4F4F"]
    self.tcolor = ['#FFFFFF', '#000000']
    #print 'Content-type: text/html'
    #print ''
    #self.get_info_from_form()
    self.get_info_from_file()
    self.get_info_from_tasks_file()
    #print self.user_info
    self.gen_html()
    
  def get_info_from_tasks_file (self):
    try:
      input = open (all_tasks_filename, 'r')
    except:
      self.error ('Could not open tasks\'s file', 1)
    for line in input.readlines():
      strtok = line[:-1].split('\t')
      try:
        if strtok[0][0] == '#' or strtok[0][0] == '':
          continue
      except:
        continue
      self.task_location[strtok[0]] = (strtok[7], strtok[8])

  def get_info_from_file (self):
    self.user_info = []
    filename = users_path + self.user + task_list_ext
    try:
      input = open (filename, 'r')
    except:
      return
      self.error ('Could not open user\'s file %s' % filename, 1)
    for line in input.readlines():
      strtok = line.split ('\t')
      new_tok = strtok[:-1]
      new_tok.append (strtok[-1][:-1])
      self.user_info.append (new_tok)
      
  def gen_html (self):
    self.print_headers ()
    self.new_print_table()
    self.print_tasks()
    self.print_footers()

  def print_banner (self, type):
    if type == 1:
      print ' <br><br>  <hr width = 400> <h2>Job duty description</h2> <hr width = 300>'
    elif type == 2:
      print '<br><br>   <hr width = 400> <h2>Roommate selection</h2> <hr width = 300>'
    elif type == 3:
      print ' <br><br>  <hr width = 400><h2>Hotel Information</h2> <hr width = 300>'

  def print_headers (self):
    print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"'
    print '   "http://www.w3.org/TR/html4/loose.dtd">'
    print '<html lang=en>'
    print '  <head>'
    print '    <meta http-equiv="Content-Type" content="text/html;charset=utf-8" >'
    print '    <link rel="STYLESHEET" title="top" media="screen"',
    print 'href="styles/middle_style.css" type="text/css" >'
    print '    <title>%s Schedule</title> ' % self.user
    print '  </head>'
    print '  <body>'
    print  '   <center>'
    print ' <br><br><hr width = 400> <H2> %s %s tasks\' schedule </H2> <hr width = 300>' % (self.user, self.last)
 
  def conv2quarters (self, time):
    startq = int (time[0] * 4.0) - 26
    endq = int (time[1] * 4.0) - 26
    dur = endq - startq
    return startq, endq, dur

  def dayc (self, date):
    if string.lower (string.strip(date)) == 'saturday':
      return 0
    elif string.lower (string.strip(date)) == 'sunday':
      return 1
    elif string.lower (string.strip(date)) == 'monday':
      return 2
    elif string.lower (string.strip(date)) == 'tuesday':
      return 3
    elif string.lower (string.strip(date)) == 'wednesday':
      return 4
    elif string.lower (string.strip(date)) == 'thursday':
      return 5
    elif string.lower (string.strip(date)) == 'friday':
      return 6
    else:
      return 7

  def new_print_table (self):
    self.convert2nums ()
    tasks_dict = {}
    for ut in self.user_times:
      tasks_dict[ut[0]] = [ut[1], self.conv2quarters (ut[2:])]
    i = 0
    mini = 0
    maxi = 0
    for td in tasks_dict.keys():
      if not i:
        mini = tasks_dict[td][1][0]
        maxi = tasks_dict[td][1][1]
      if mini > tasks_dict[td][1][0]:
        mini = tasks_dict[td][1][0]
      if maxi < tasks_dict[td][1][1]:
        maxi = tasks_dict[td][1][1]
      i = i + 1
    qua_dict = {'mini_max':[mini, maxi]}


    for i in range (mini - 1, maxi + 2):
      qua_dict[i] = []
      for j in range (7):
        qua_dict[i].append(0)
    cc = 0
    for td in tasks_dict.keys():
      bgcolor = self.colors[cc]
      if cc > 11:
        txtcolor = self.tcolor[0]
      else:
        txtcolor = self.tcolor[1]
      if cc > 21:
        cc = 0
      else:
        cc = cc + 1
      self.user_colors[td] = [bgcolor, txtcolor]
      day = self.dayc (tasks_dict[td][0])
      qua_dict[tasks_dict[td][1][0]][day] = \
          [td, tasks_dict[td][1][2], self.dayc(tasks_dict[td][0]), bgcolor, txtcolor]
      for i in range (tasks_dict[td][1][0] + 1, tasks_dict[td][1][1]):
        qua_dict[i][day] = 1
        
    print '    <table border=0 cellpadding=0 cellspacing=0>'
    print '      <tr>'
    #print '        <th>\\day<br>time</th>'
    print '        <th>time</th>'
    for day in self.dateswday:
      print '        <th width=70>%s</th>' % day
    #print '        <th>day\\time   </th>'
    print '        <th>time</th>'
    print '      </tr>'
    max_user_hours = maxi - mini
    max_slots = max_user_hours + 4
    for hour in range (mini - 2, mini + max_slots):
      #calculating the printing time
      start_str =  self.conv_hr2str (hour)
      #start row
      print '      <tr>'
      #starting with time
      if (hour%2==0):
        print '        <td align="right" rowspan=2 valign="top">%s</td>' % start_str
      if not qua_dict.has_key (hour):
        for i in range (7):
          print '        <td>&nbsp;</td>'
      else:
        for q in qua_dict[hour]:
          if not q:
            print '        <td>&nbsp;</td>'
          elif q == 1:
            continue
          else:
              print '        <td rowspan=%d align="center" bgcolor="%s"><font color="%s">%s</font></td>' % \
                  (q[1], q[3], q[4], q[0])
      if (hour%2==0):
        print '        <td align="right" rowspan=2 valign="top">%s</td>' % start_str
      print '      </tr>'
    print '    </table>'
#    print qua_dict

  def conv_hr2str (self, quarters):
    hour = (quarters + 26)/ 4
    minutes = (quarters + 26 )% 4 * 15
    if not minutes:
      hr_str = '%s:0%s' % (hour, minutes)
    else:
      hr_str = '%s:%s' % (hour, minutes)
    return hr_str

  def convert2nums (self):
    i = 0
    self.user_times = []
    mini = maxi = 0.0
    #print 'here, here'
    for ui in self.user_info:
      start_tok = ui[4].split(':')
      start_time = string.atof (start_tok[0]) + string.atof(start_tok[1])/60.0
      end_tok = ui[5].split(':')
      end_time = string.atof (end_tok[0]) + string.atof(end_tok[1])/60.0
      duration_time = end_time - start_time
      if i == 0:
        mini = start_time
        maxi = end_time
        i = 1
      if mini > start_time:
        mini = start_time
      if maxi < end_time:
        maxi = end_time
      self.user_times.append ((ui[0], ui[3], start_time, end_time, duration_time))
    self.mini = mini
    self.maxi = maxi
    #print self.user_times

  def print_tasks (self):
    print '    <br><br>'
    print '    <table border cellpadding=1 cellspacing=0>'
    print '      <tr>'
    print '        <th>TaskID</th>'
    print '        <th>Category</th>'
    print '        <th>Date</th>'
    print '        <th>Start time</th>'
    print '        <th>End time</th>'
    print '        <th>Duration</th>'
    print '      </tr>'
    for ui in self.user_info:
      print '      <tr>'
      i = 0
      for u in ui[:-1]:
        if i == 0:
          #print '<br> user colors'
          #print self.user_colors
          print '        <td align="center" bgcolor="%s"><font color="%s">%s</font>' % \
               (self.user_colors[u][0], self.user_colors[u][1], u)
        else:
          if i not in [2, 7]:
            if i==3:
               print '        <td>%s %s</td>' % (u, day_str)
            else:
               print '        <td align="center">%s</td>' % u
          else:
            if i <> 2:
              pass
            else:
              day_str = u
        i = i + 1
      print '      </tr>'
    print '    </table>'
    print '    <br><br>'
    print '    <table border cellpadding=1 cellspacing=0>'
    print '      <tr>'
    print '        <th>TaskID</th>'
    print '        <th>Task Description</th>'
    print '        <th>Location</th>'
    for ui in self.user_info:
      print '      <tr align="left">'
      print '        <td bgcolor="%s"><font color="%s">%s</font>' % \
         	      (self.user_colors[ui[0]][0], self.user_colors[ui[0]][1], ui[0])
      print '        <td align="left">%s</td>' % self.task_location[ui[0]][0]
      print '        <td align="left">%s</td>' % self.task_location[ui[0]][1]
      print '      </tr>'
    print '    </table>'

    self.print_banner (1)
    print '    <br><br>'
    print '<a href="http://vgtc.org/jobs.html">You can find the job duty descriptions here</a>'
    print '    <br><br>'
    
  def print_footers (self):
    print '    <br><br><br><br>'
    #print '        <form name ="myDropForm" action="drop_task.py" onsubmit="return drop_task()">'
    #print '          <input type="hidden" name="user" value="%s">' % self.user
    #print '          <input type="hidden" name="last_name" value="%s">' % self.last
    #print '          <input type="hidden" name="drop_taskID" value="0">'
    #print '          <input type="submit" value="Back" class="drop_button">'
    #print '        </form>'    
    print  '    </center>'
    print '    <br><br><br><br>'
    print  '  </body>'
    print  '</html>'

  def error (self, text, type):
    display_tasks.display_tasks(self.user, self.last, type, text)
    sys.exit(0)

#main
#display_schedule ()
