#!/usr/bin/env python

from time import time, strftime, localtime
import sys, string
from task_colors import get_task_colors

task_list = {}
user_list = []
error = []
categories = [
  (1, 0.0, 6.0),
  (2, 0.0, 7.0),
  (3, 0.0, 6.0),
  (4, 0.0, 6.0),
  (5, 0.0, 8.0),
  (6, 0.0, 2.0),
  (7, 0.0, 1.0),
  (8, 0.0, 18.0)
  ]

cats = ['1', '2', '3','4', '5', '6', '7', '8']


def display_tasks (first, last, msg_num = 0, msg_str = ''):
  get_info_from_file(first)
  if error:
    print_error (first)
  else:
    print_body (first, last)
    print_buttons (first, last)
    print_footers (msg_num, msg_str, first, last)

def get_info_from_file (user):
  filename = 'task_data/users/' + user + '_tl.txt'
  try:
    input = open (filename, 'r')
  except:
    user_list = []
    return
  user_list = []
  for line in input.readlines():
    strtok = line.split('\t')
    try:
      strtok[0]
    except:
      continue
    if strtok[0][0] == '#':
      continue
    user_list.append (strtok)
  for c in cats:
    add = 0.0
    t_list = []
    for ul in user_list:
      if c == ul[1]:
        tok = ul[4].split (':')
        tok2 = ul[5].split(':')
        temp = (string.atof(tok[0]), string.atof(tok[1]),\
               string.atof(tok2[0]), string.atof(tok2[1]))
        nt = (temp[0] + temp[1]/60.0, temp[2] + temp[3]/60.0)
        tt = nt[1] - nt[0]
        add = add + tt
        t_list.append ((ul[0], tt, ul[3], ul[2], ul[4], ul[5]))
    cat_name = 'cat_' + c
    task_list[cat_name] = [add, t_list]
       

def print_error (user):
  print  '  There was an error:<p></p>'
  for e in error:
   print  '%s<br>' % e 
  print  '  </body>'
  print  '</html>'

def any_task_in ():
  for tl in task_list.keys():
    if task_list [tl][0] > 0:
      return 1
  return 0

def print_body(first, last):
  print '<span class="heading"><b>Quick Actions</b></span>'
#  print ' <table width=100%><tr><td>'
  print '    <form name ="myForm" action="add_task.py" onsubmit="update_form(\'myForm\'); return validate()">'
  print '      <input type="hidden" name="checked_boxes" value="">'
  print '      <input type="hidden" name="sort_by" value="">'
  print '      <input type="hidden" name="task_availability" value="">'
  print '      <input type="hidden" name="search_criterion" value="">'
  print '      <input type="hidden" name="user" value="%s">' % first
  print '      <input type="hidden" name="last_name" value="%s">' % last
  print '      <table>'
  print '        <tr>'
  print '          <td align="center" class="add_taskid">Add Task by ID:'
  print '<input type="text" name="taskID" size=9 class="add_text"> </td>'
  print '          <td align="center" valign="middle"> <input type="submit" value="Add it!" class="add_button">'
  print '        </tr>'
  print '      </table>'
  print '    </form>'
#  print ' </td>'
  if any_task_in():
    # Drop button
#    print ' <td align=right>'
    print '        <form name ="myDropForm" action="drop_task.py" onsubmit="update_form(\'myDropForm\'); return drop_task_confirm()">'
    print '        <input type="hidden" name="checked_boxes" value="">'
    print '        <input type="hidden" name="sort_by" value="">'
    print '        <input type="hidden" name="task_availability" value="">'
    print '        <input type="hidden" name="search_criterion" value="">'
    print '        <input type="hidden" name="user" value="%s">' % first
    print '        <input type="hidden" name="last_name" value="%s">' % last
    print '        <table>'
    print '          <tr>'
    print '            <td align="center" class="drop_taskid" >Drop Task by ID: '
    print '<input type="text" name="drop_taskID" size=5 class="drop_text"> </td>'
    print '            <td align="center" valign="middle"> <input type="submit" value="Drop It!" class="drop_button">'
    print '          </tr>'
    print '        </table>'
    print '        </form>'
#   print ' </td>'
#   print '</tr></table>'

  print '        <form name="showSchedule" action="refresh.py" onclick="update_form(\'showSchedule\'); return true;">'
  print '          <input type="hidden" name="checked_boxes" value="">'
  print '          <input type="hidden" name="sort_by" value="">'
  print '          <input type="hidden" name="task_availability" value="">'
  print '          <input type="hidden" name="search_criterion" value="">'
  print '          <input type="hidden" name="user" value="%s">' % first
  print '          <input type="hidden" name="last_name" value="%s">' % last
  print '          <input type="submit" value="Refresh Task List" class="drop_button">'
  print '        </form>'

  print '<hr>'

  display_begin_table()
  display_end_table_titles()
  for cat in categories:
    display_categories (cat)
    if any_task_in ():
      display_tasks_already_in(cat)
  print_totals()

def print_totals ():
  #print '            <tr>'
  #print '            </tr>'
  print '            <tr >'
  print '              <td align="center">Total hours<br>needed</td>'
  print '              <td bgcolor="#F3F300"><font color="#000000">22.0</font></td>'
  #print '              <td align="center">22</td>'
  print '              <td align="center">Total<br>Hours<br>registered</td>'
  task_total = 0.0
  for k in task_list.keys():
    task_total = task_total + task_list[k][0]
  if task_total < 22.0:
    print '      <td bgcolor="#00AA00"><font color="#FFFFFF">%.1f</font></td>' % task_total
  elif task_total > 21.0:
    print '      <td bgcolor="#AA0000"><font color="#FFFFFF">%.1f</font></td>' % task_total
  else:
    print '      <td bgcolor="#CCCCCC"><font color="#000000">%.1f</font></td>' % task_total
  print '            </tr>'


def display_begin_table ():
  print '  <center>'
  print '  <table class="largeview" border=1>'
  print '    <tr>'
  print '      <th>  Category              </th>'
  print '      <th>  Minimum      </th>'
  print '      <th>  Maximum      </th>'
  print '      <th>  Current   </th>'

def display_end_table_titles ():
  if any_task_in():
    print '      <td>'
    print '      <table>'
    print '        <tr>'
    print '          <th align="center" width="60">ID</th>'
    print '          <th align="right" width="50">Duration</th>'
    print '          <th align="center" width="100">Date</th>'
    print '          <th align="right" width="150">Time</th>'
    print '        </tr>'
    print '      </table>'
    print '      </td>'
  print '    </tr>'

def display_categories (cat):
  print '    <tr>' # end of last row
  print '      <td>%d</td>' % cat[0]
  if cat[1] == 1.5 :
    print '      <td>%.1fh</td>' % cat[1]
    print '      <td>%.1fh</td>' % cat[2]
  else:
    print '      <td>%dh</td>' % cat[1]
    print '      <td>%dh</td>' % cat[2]
  cat_name = 'cat_%d' % cat[0]
  if not task_list.has_key (cat_name):
    print '      <td>0.0h</td>'
    return
  if task_list[cat_name][0] == 0:
    print '      <td bgcolor="#CCCCCC"><font color="#000000">%.1fh</font></td>' % task_list[cat_name][0]
  elif cat[2] < task_list[cat_name][0]:
    print '      <td bgcolor="#AA0000"><font color="#FFFFFF">%.1fh</font></td>' % task_list[cat_name][0]
  elif cat[1] > task_list[cat_name][0]:
    print '      <td bgcolor="#00AA00"><font color="#FFFFFF">%.1fh</font></td>' % task_list[cat_name][0]
  else:
    print '      <td bgcolor="#CCCCCC"><font color="#000000">%.1fh</font></td>' % task_list[cat_name][0]

  

def display_tasks_already_in (cat):
  cat_name = 'cat_%d' % cat[0]
  print '        <td>'
  print '          <table width="100%"  cellpadding=10>'
  if task_list[cat_name][0]:
    for tl in task_list[cat_name][1]:
       bgcolor, fgcolor = get_task_colors(tl[0])
       print '            <tr>'
       #print '              <td width=33' + '\%' + '> %s </td>' % tl[0]
       print '              <td align="center" width="60" bgcolor="%s"> ' % bgcolor
       print '<font color="%s">%s</font>' % (fgcolor, tl[0])
       print '<a href="" onclick="drop_task(%s); return false;">Drop</a>' % tl[0]
       print '</td>'
       print '              <td align="center" width="50"> ',
       print '%.1fh </td>' % tl[1]
       print '              <td align="center" width="100"> ',
       print '%s %sth </td>' % (tl[2][:3], tl[3][3:5])
       print '              <td align="center" width="150"> ',
       print '%s to %s hrs.</td>' % (tl[4], tl[5])
       #print '              </td>' 
       print '            </tr>' 
  else:
    print '            <tr>'
    print '              <td align="center" width="50">--</td>'
    print '              <td align="center" width="50">--</td>'
    print '              <td align="center" width="150">--</td>'
    print '              <td align="center" width="150">--</td>'
    print '            </tr>'
  print '           </table>'
  print '         </td> '
  print '    </tr>'

def print_buttons (first, last):
  print '   </table>'
  print '<p></p>'
  print '<br>'
  print ' <span class="heading"><b>Color Legend for Column "Current":</b></span><br>'
  print '  <table border cellpadding=2 class="calendarview">'
  print '  <tr>'
  print '     <td bgcolor="#00AA00"><font color="#FFFFFF">Need to add<br>more hours</font></td>'
  print '     <td bgcolor="#CCCCCC"><font color="#000000">Safe zone.<br>You might need to<br>\
                                                                      add more hours if total is<br>\
                                                                      not reached yet</font></td>'
  print '     <td bgcolor="#AA0000"><font color="#FFFFFF">You have more<br>hours than required</font></td>'
  print '     <td bgcolor="#F3F300"><font color="#000000">Total number of<br>hours needed</font></td>'
  print '  </tr>'
  print '  </table>'
  print '<hr>'

def print_footers (msg_num, msg_str, first, last):
  print  '    </center>'
  if msg_num:
    print '<script type="text/javascript" language="Javascript">'
    print '<!--'
    if msg_num == 1:
      print 'alert ("%s,\\nplease contact the  SV chairs (vis08sv@gmail.com)")' % msg_str
    else:
      print 'alert ("%s")' % msg_str
    print '//-->'
    print '</script>'
  print  '  </body>'
  print  '</html>'


#main
#validate_password()
