#!/usr/bin/env python

import sys, string, os
import display_tasks
import portalocker
from time import time, strftime, localtime
import get_form_info
import nice_display
from global_vars import *

class drop_task:
  def __init__ (self):
    self.get_info_from_form()
    self.get_user_info()
    self.check_existance()
    self.write_task()
    self.end(0, 'task %s has been removed from your list. If this was a mistake' % self.taskID)


  def check_existance (self):
    self.new_list = []
    found_it = 0
    if self.taskID == '0':
      self.error ('', 0)
    for ul in self.user_list:
      if self.taskID <> ul[0]:
        self.new_list.append (ul)
      else:
        self.task2delete = ul
        found_it = 1
    if not found_it:
      self.error ('(201) Task %s is not in your list.' % self.taskID, 2)

      

  
  def file_exist (self, filename):
    try:
      input = open (filename, 'r')
    except:
      return 0
    input.close()
    return 1

  def write_task (self):
    # define paths and names for the task (such as 120.txt, 338.txt) 
    # where 120 and 338 are task numbers
    path_category = 'task_data/tasks_checked/category_'+ self.task2delete[1] + '/'
    task_ID_fn  = path_category + self.taskID + '.txt'
    # The easiest check: if file exist, then the task is taken
    if not self.file_exist (task_ID_fn):
      self.error ('(202) task %s is not checked out.' % self.taskID, 2)
    # define paths and filenames for users (such as Alejandro_tl.txt, Robert_tl.txt)
    # where Alejandro and Robert are users and the file contains all the tasks assigned to 
    # that person.
    user_log_fn = users_path + self.user + '_log.txt'
    user_task_list_fn = users_path + self.user + '_tl.txt'

    # First, look for user's lock. This would ensure mutex
    try:
      user_log = open(user_log_fn, "a+")
    except Exception, e: # lock on, go back and let user try again
      self.error ("(203) User's file is busy (probably used in another window). \\nIf you think this is a mistake %s" % str(e), 1)
    try: # user's file is open. Now needs to be locked
      portalocker.lock(user_log, portalocker.LOCK_EX)
    except:
      self.error ("(204) User's file is busy (probably used in another window). \\nIf you think this is a mistake", 1)
      
    # if here, then log file is opened and locked
    # open user's config file (e.g. Alejandro_tl.txt)
    try:
      user_task_list = open (user_task_list_fn, 'w')
    except:
      user_log.close()
      self.error ('(205) There was a problem with user\'s task file', 1)
    # Now, just remove file
    try:
      os.remove (task_ID_fn)
    except:
      user_log.close()
      self.error ('(206) There is a problem while removing task %s ' % self.taskID, 1)
    for nl in self.new_list:
      for i in range (len(nl)-1):
        user_task_list.write('%s\t' % nl[i])
      user_task_list.write ('%s\n' % nl[i+1][:-1])
    # get local time
    timestamp = strftime(" %m/%d/%Y %H:%M:%S\n", localtime(time()))
    # write the timestamp in the log (just for control)
    user_log.write (self.user + ' - ' + self.taskID + timestamp)
    user_log.close()
    user_task_list.close()
     
  def get_user_info (self):
    filename = users_path + self.user + '_tl.txt'
    try:
      input = open (filename, 'r')
    except:
      try:
        input = open (filename,'w')
      except:
        self.error ('(207) Could not open user file', 1)
      self.user_list = []
      return
    self.user_list = []
    for line in input.readlines():
      strtok = line.split('\t')
      try: 
        strtok[0]
      except:
        continue
      if strtok[0][0] == '#':
        continue
      self.user_list.append (strtok)
    input.close()
    
      
  def error (self, text, type):
    nice_display.display_it_all(type, text)
    sys.exit(0)

  def get_info_from_form(self):
    try:
      self.form=get_form_info.get_form()
    except:
      self.error ('(208) Getting info from form', 1)
      return
    self.user = self.form['user'].value
    self.last_name = self.form['last_name'].value
    self.taskID = string.strip (self.form['drop_taskID'].value)
  
      
  def end (self, msg_num = 0, msg_str=""):
    nice_display.display_it_all()
#     display_tasks.display_tasks(self.user, self.last_name, msg_num, msg_str)
    
# main
drop_task()
