#!/usr/bin/env python

from global_vars import *
import tasks
import cgi
import display_progress
import display_tasks
import sys
import get_form_info
import utils

form = get_form_info.get_form()

##############################################################################

def print_cgi_headers():
    print 'Content-type: text/html'
    print ''

def print_html_headers():
    print r"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">
    <html lang=en>
    <head>"""
    user = form['user'].value
    try:
        last_name = utils.get_password_list()[user][0]
    except:
        last_name = ''
    print ("<title>VisWeek 2009 SV Task Selection page for %s %s</title>" %
           (user, last_name))
    print """<link rel="stylesheet" href="/styles/pas_style.css">
  <script rel="javascript" type="text/javascript" src="/jvs/tasks.js" >
  </script>
  <script src="/jvs/validate.js"
          language="javascript" 
          type="text/javascript"></script>
  <script src="/jvs/drop_task.js" 
          language="javascript" 
          type="text/javascript"></script>
<script rel="javascript" type="text/javascript">"""
    print 'all_tasks = ['
    # Now find all tasks
    for task in tasks.read_all_tasks():
        print "    %s," % task.dump_js()
    print '    ];'
    print '</script>'
    print "</head>"

def print_html_body():
    user = form['user'].value
    try:
        last_name = utils.get_password_list()[user][0]
    except:
        last_name = ''
    try:
        password = utils.get_password_list()[user][2]
    except:
        password = ''
    
    print """<body>
    <table width=100% cellspacing=10>
    <tr>
    <td width = 40% valign=top>"""

    display_tasks.display_tasks(user, last_name)
    print '<span class="heading">%s\'s <b>Calendar View</b>:</span>' % user
    print "<br>"
    print "<br>"
    dp = display_progress.display_progress()
    dp.print_table()
    print '<hr>'
    print '<span class="heading">%s\'s <b>task summary</b>:</span>' % user
    print "<br>"
    print "<br>"
    dp.print_tasks()
    print '<hr>'
    print """
    </td>
    <td width = 60% valign=top>"""

    print '<span class="heading"><b>Task Search Form</b></span><br>'

    print '<form name="search">'
    try:
        input_val = form['search_criterion'].value
    except:
        input_val = ""
    print '      <input type="hidden" name="checked_boxes" value="">'
    print '          <input type="hidden" name="user" value="%s">' % user
    print '          <input type="hidden" name="last_name" value="%s">' % last_name
    print '          <input type="hidden" name="password" value="%s">' % password
    print '<input type="text" name="search_criterion" value="%s" size=60>' % input_val
    print '<input type="submit" value="Search" action="refresh.py" onclick="perform_search(); return false;">'
    print '<input type="submit" value="Clear" action="refresh.py" onclick="clear_search(); return false;"><br>'
    
    d = { True:"checked", False:"" }
    if form.has_key('task_availability'):
        v = form['task_availability'].value
    else:
        v = 'available'
        
    print 'Search <input type="radio" name="task_availability" value="all" %s onchange="perform_search(); return false;"> All tasks' % d[v == "all"]
    print '<input type="radio" name="task_availability" value="available" %s onchange="perform_search(); return false;"> Available tasks<br>' % d[v == "available"]
    if form.has_key('sort_by'):
        v = form['sort_by'].value
    else:
        v = 'date'
        
    print 'Sort by '
    print '<input type="radio" name="sort_by" value="date" %s onchange="perform_search(); return false;">date' % d[v == "date"]
    print '<input type="radio" name="sort_by" value="id" %s onchange="perform_search(); return false;">task ID' % d[v == "id"]
    print '<input type="radio" name="sort_by" value="length" %s onchange="perform_search(); return false;">task length' % d[v == "length"]


    print '<br>'
    print '<table cellspacing=0 cellpadding=0><tr><td valign=top>Include these categories:</td><td>'
    print '<table cellspacing=0 cellpadding=0>'
    print '<tr><td align=center>1</td><td align=center>2</td><td align=center>3</td><td align=center>4</td><td align=center>5</td><td align=center>6</td><td align=center>7</td><td align=center>8</td></tr><tr>'
    if form.has_key("checked_boxes"):
        s = form["checked_boxes"].value
    else:
        s = "123456789"
    for i in xrange(1,9):
        print '<td><input type="checkbox" name="cat%d" %s onchange="perform_search(); return false;"></td>' % (i, d[str(i) in s])
    print '</tr></table></td></tr></table>'
    print '</form><br>'

    print """<div id="tasklist"></div>
    </td>
    </tr>
    </table>
<script rel="javascript" type="text/javascript">
var tasklist_div = document.getElementById("tasklist");
tasklist_div.appendChild(task_table("""
    task_search_functions = {
        "all": "function (t) { return document.search['cat' + t.category].checked && t.name.match(new RegExp('%s', 'i')); }" % input_val,
        "available": "function (t) { return document.search['cat' + t.category].checked && t.available && t.name.match(new RegExp('%s', 'i')); }" % input_val
        }
    task_sort_functions = {
        "date": "sort_table_by_date",
        "id": "sort_table_by_id",
        "duration": "sort_table_by_duration"
        }
    try:
        print task_search_functions[form['task_availability'].value], ","
    except KeyError:
        print task_search_functions["available"], ","
    try:
        print task_sort_functions[form['sort_by'].value]
    except KeyError:
        print task_sort_functions["date"];
    print "));</script>"

def print_html_footers():
    print "</body></html>"

##############################################################################

def display_it_all(msg_num=None, msg_str=None, force_reset=True):
    print_cgi_headers()
    print_html_headers()
    print_html_body()
    if msg_num:
        print '<script type="text/javascript" language="Javascript">'
        print '<!--'
        if msg_num == 1:
            print 'alert ("%s,\\nplease contact the  SV chairs (vis08sv@gmail.com)")' % msg_str
        else:
            print 'alert ("%s")' % msg_str
        print '//-->'
        print '</script>'
    print_html_footers()
    sys.exit(0)

# display_it_all()
