#!/usr/bin/env python

# Reads the entire database and produces a summary of students and their
# tasks
##############################################################################

import cgitb
cgitb.enable()
from tasks import read_all_tasks
from global_vars import *
import display_progress
from get_form_info import get_form

tasks = dict((t.id, t) for t in read_all_tasks())

for task in tasks.itervalues():
    task.set_owner()

def nice_time(minutes):
    return "%d:%02d" % (minutes / 60, minutes % 60)

def ascii_time_to_int(t):
    (h, m) = list(int(i) for i in t.split(':'))
    return h * 60 + m

user = get_form()["name"].value

print "Content-type: text/html\n"
print '<html><head><title>Tasks for %s</title><link rel="stylesheet" href="/styles/pas_style.css"></head><body>' % user

dp = display_progress.display_progress(user, 'asdf')

print '<table><tr><td>'
# 2 is date, 4 is start time
dp.print_tasks(False, sort_key=lambda k: (k[2], ascii_time_to_int(k[4]))) 
print '</td><td>'
dp.print_table()
print '</td></tr></table></body></html>'
