#!/usr/bin/env python

# syntax:
# generate_password_list.py file_in file_out

# Takes a file with the following format:
# FirstName RemainingNames email1 email2
# (RemainingNames can have spaces in it)
# and produces a password file that the SV task selection application understands

import random
import sys

def random_string():
    """Procudes a random string that can be typed in a standard keyboard"""
    letter_list = (list(chr(i) for i in xrange(ord('A'), ord('Z'))) +
                   list(chr(i) for i in xrange(ord('0'), ord('9'))) +
                   list(chr(i) for i in xrange(ord('a'), ord('z'))))
    return "".join(list(random.choice(letter_list) for _ in xrange(12)))

inf = file(sys.argv[1], 'r')
outf = file(sys.argv[2], 'w')

for l in inf:
    words = l.strip().split()
    firstname = words[0]
    lastname = "_".join(words[1:-2])
    primary_email = words[-2]
    pw = random_string()
    outf.write('%s,%s,%s,%s,\n' % (firstname, lastname, primary_email, pw))

inf.close()
outf.close()
