#!/usr/bin/env python

##############################################################################
# restore_from_backup.py
#
# Restore the database from a backed up zip file created by cleanup_files.py
#
# Must run as root for the same reason as cleanup_files.py
#

import os
import os.path
import sys

if os.getuid() != 0:
    print "Must run as root"
    sys.exit(1)

file_owner = 'www-data'

try:
    backup_file = sys.argv[1]
except:
    print "Usage: "
    print "  %s backup_filename" % sys.argv[0]
    sys.exit(1)

if not os.path.isfile(sys.argv[0]):
    print "File does not exist"
    sys.exit(1)

if os.system('unzip -t %s' % backup_file) != 0:
    print "ERROR: backup file corrupted or not succesfully open"
    sys.exit(1)

if not os.path.realpath(os.path.curdir).endswith('task_data'):
    print "Please run this from the task_data directory"
    sys.exit(1)
if not os.path.isdir('tasks_checked'):
    print "ERROR:"
    print "Could not find tasks_checked directory - file structure corrupt?"
    sys.exit(1)
if not os.path.isdir('users'):
    print "ERROR:"
    print "Could not find users directory - file structure corrupt?"
    sys.exit(1)

if os.system("sudo -u %s unzip %s" % (file_owner, backup_file)) != 0:
    print "ERROR: restoring backup file failed"
    sys.exit(1)
